<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<span *ngFor="let step of stepList; let isLast = last">

  <button
    *ngIf="isMainActionEnabled && !shouldHideArchiveAction(step)"
    type="button"
    class="me-2 mb-2 btn"
    [ngClass]="{
      'btn-secondary': externalActionWaitingStatus(step),
      'btn-primary': !externalActionWaitingStatus(step) && step.action !== actionEnum.Delete,
      'btn-danger': step.action === actionEnum.Delete
    }"
    (click)="openModal(step, step.action)">
    <fa-icon class="me-1" [icon]="step.action | actionIcon"></fa-icon>
    <span *ngIf="!externalActionWaitingStatus(step)" [innerText]="step.action | actionName: true"></span>
    <span *ngIf="!isSignedExternalSignature(step) && externalActionWaitingStatus(step)" [innerText]="commonMessages.INFOS"></span>
    <span *ngIf="isSignedExternalSignature(step)" [innerText]="commonMessages.FORCE_STEP_NOW"></span>
    <span
      class="me-2"
      *ngIf="externalActionWaitingStatus(step)"
      [innerText]="messages.taskStatus(step.externalState | ExternalState)">
    </span>
  </button>

  <button
    *ngIf="isPaperSignable(step)"
    type="button"
    class="me-2 mb-2 btn btn-outline-primary"
    (click)="openModal(step, actionEnum.PaperSignature)">
    <fa-icon
      class="me-1"
      [icon]="actionEnum.PaperSignature | actionIcon">
    </fa-icon>
    {{ actionEnum.PaperSignature | actionName: true }}
  </button>

  <button
    *ngIf="isUndoable(step)"
    type="button"
    class="me-2 mb-2 btn btn-outline-primary"
    (click)="openModal(step, actionEnum.Undo)">
    <fa-icon
      class="me-1"
      [icon]="actionEnum.Undo | actionIcon">
    </fa-icon>
    {{ actionEnum.Undo | actionName: true }}
  </button>

  <button
    *ngIf="isBypassable(step)"
    type="button"
    class="me-2 mb-2 btn btn-outline-primary"
    (click)="openModal(step, actionEnum.Bypass)">
    <fa-icon
      class="me-1"
      [icon]="actionEnum.Bypass | actionIcon">
    </fa-icon>
    {{ actionEnum.Bypass | actionName: true }}
  </button>

  <button
    *ngIf="isRejectable(step)"
    type="button"
    class="me-2 mb-2 btn btn-danger"
    (click)="openModal(step, actionEnum.Reject)">
    <fa-icon
      class="me-1"
      [icon]="actionEnum.Reject | actionIcon">
    </fa-icon>
    {{ actionEnum.Reject | actionName: true }}
  </button>

  <button
    *ngIf="isRecyclable(step)"
    type="button"
    class="me-2 mb-2 btn btn-outline-primary"
    (click)="openModal(step, actionEnum.Recycle)">
    <fa-icon
      class="me-1"
      [icon]="actionEnum.Recycle | actionIcon">
    </fa-icon>
    {{ actionEnum.Recycle | actionName: true }}
  </button>

  <button
    *ngIf="isDeletableAsSecondaryAction(step)"
    type="button"
    class="me-2 mb-2 btn btn-outline-danger"
    (click)="openModal(step, actionEnum.Delete)">
    <fa-icon
      class="me-1"
      [icon]="actionEnum.Delete | actionIcon">
    </fa-icon>
    {{ actionEnum.Delete | actionName: true }}
  </button>

  <button
    *ngIf="isArchivableAsSecondaryAction(step)"
    type="button"
    class="me-2 mb-2 btn btn-outline-primary"
    (click)="openModal(step, actionEnum.Archive)">
    <fa-icon
      class="me-1"
      [icon]="actionEnum.Archive | actionIcon">
    </fa-icon>
    {{ actionEnum.Archive | actionName: true }}
  </button>

  <span
    *ngIf="isLast"
    ngbDropdown
    container="body"
    #secondaryActionDropdown="ngbDropdown">

    <button
      class="me-2 mb-2 btn btn-outline-secondary"
      type="button"
      id="secondary_actions_dropdown"
      name="secondary_actions_button"
      ngbDropdownAnchor
      (focus)="secondaryActionDropdown.open()"
      [innerText]="commonMessages.ACTIONS">
    </button>

    <span
      ngbDropdownMenu
      aria-labelledby="secondary_actions_dropdown">

      <ng-container *ngFor="let action of secondaryActionList">

        <a
          *ngIf="isSecondaryActionAvailable(action, step)"
          (click)="openModal(step, action)"
          [name]="'secondary_actions_menu_link_' + action.toLowerCase()"
          class="pointer"
          target="_self"
          [class.disabled]="!isLinkEnabled(action)"
          ngbDropdownItem>
          <fa-icon
            class="me-2 text-secondary"
            [icon]="action | actionIcon"
            [fixedWidth]="true">
          </fa-icon>
          <span [innerText]="action | actionName: false"></span>
        </a>

      </ng-container>

    </span>
  </span>

</span>


<!-- Alternative Action button - displayed when the user has no active task on the folder (eg when viewing it as supervisor) -->
<span
  *ngIf="!stepList || stepList.length === 0"
  ngbDropdown
  container="body"
  #myAltDrop="ngbDropdown">

  <button
    class="me-2 mb-2 btn btn-outline-secondary"
    type="button"
    id="dropdownManualAlt"
    ngbDropdownAnchor
    (focus)="myAltDrop.open()"
    [innerText]="commonMessages.ACTIONS">
  </button>

  <span
    ngbDropdownMenu
    aria-labelledby="dropdownManualAlt">

    <ng-container *ngFor="let action of alternativeActionList">

      <a
        *ngIf="isSecondaryActionAvailable(action, null)"
        ngbDropdownItem
        (click)="openModal(null, action)"
        class="pointer"
        target="_self">
        <fa-icon
          class="me-2 text-secondary"
          [icon]="action | actionIcon"
          [fixedWidth]="true">
        </fa-icon>
        <span [innerText]="action | actionName: false"></span>
      </a>

    </ng-container>

  </span>
</span>
